// -*- C++ -*- (c) 2013 Vladimír Štill <xstill@fi.muni.cz>

#include <memory>
#include <divine/algorithm/common.h>

#ifndef DIVINE_INSTANTIATE_SELECT
#define DIVINE_INSTANTIATE_SELECT

namespace divine {

namespace instantiate {

struct SupportedBy;
struct Key;
bool _evalSuppBy( const SupportedBy &suppBy, const std::vector< Key > &vec );
bool _valid( std::vector< Key > trace );

template< typename Trace >
std::string stringTrace( Trace trace ) {
    std::vector< std::string > vec;
    for ( auto i : trace )
        vec.emplace_back( std::get< 1 >( showGen( i ) ) );
    return brick::string::fmt( vec );
}

}

using AlgorithmPtr = std::unique_ptr< algorithm::Algorithm >;
std::vector< instantiate::Key > selectTrace( Meta &meta );
AlgorithmPtr select( Meta &meta );

}

#endif // DIVINE_INSTANTIATE_SELECT
